/* Nemesis
 * Copyright (C) 1999 John Ferlito <johnf@inodes.org>
 * Copyright (C) 1998 Gerd Knorr <kraxel@goldbach.in-berlin.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*
 * misc colorspace conversion functions
 *
 * most of them have common arguments (wanna be able to use function
 * pointers):
 *	 foo(unsigned char* dest, unsigned char* src, int width, int height);
 *
 *
 */

#include "colorspace.h"


/* ------------------------------------------------------------------- */
/* RGB conversions                                                     */

void
rgb24_to_bgr24(unsigned char *dest, unsigned char *src, int w, int h)
{
    register char *s = src;
    register char *d = dest;
    register int   i = w*h;

    while (--i) {
	*(d++) = s[2];
	*(d++) = s[1];
	*(d++) = s[0];
	s += 3;
    }
}

void
bgr24_to_bgr32(unsigned char *dest, unsigned char *src, int w, int h)
{
    int             i    = w*h;

    while (i--) {
        *(dest++) = *(src++);
        *(dest++) = *(src++);
        *(dest++) = *(src++);
	*(dest++) = 0;
    }
}

